; AutoIt Version: 3.3.0
; Language: blahblah
; Platform: Win9x/NT
; Author: yanni
; Script Function: kmeleon extension installer turbo helper (online/offline installer)

#NoTrayIcon
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <StaticConstants.au3>
#include <ButtonConstants.au3>
#include <ProgressConstants.au3>
#Include <String.au3>
#Include <File.au3>
#Include <Array.au3>

If FileExists(@ScriptDir & "\exthelper.ini") Then
$kmpath = IniRead(@ScriptDir & "\exthelper.ini", "kmeleon", "1", "default")
Else
$kmpath = FileSelectFolder("Select K-Meleon's Folder: (the path where K-Meleon is installed)", "")
    IniWrite(@ScriptDir & "\exthelper.ini", "kmeleon", 1, $kmpath)
    EndIf

$deletable1 = ($kmpath & "\components\compreg.dat")
$deletable2 = ($kmpath & "\components\xpti.dat")
$kmbinary=($kmpath & "\k-meleon.exe")

if $CmdLine[0] = 0 Then
$extpath = FileOpenDialog("Select Extension", @WorkingDir & "", "K-Meleon Compressed Extensions (*.7z)", 1)
checker()
ElseIf $CmdLine[0] = 1 Then
$extpath =$CmdLine[1]
extsite()
EndIf

Func extsite()
$onlinecheck=StringRegExp($extpath, "(?i)http://")
if $onlinecheck=1 Then
isvalid()
Else
checker()
Endif
Endfunc

Func isvalid()
$valid=StringRegExp($extpath, "(?i)http://kme")
if $valid=1 Then
onlinechecker()
Else
MsgBox(48, "KEITH Error", "Invalid website. K-Meleon extensions can only be downloaded from K-Meleon's extensions websites")
Endif
Endfunc

Func checker()
$checkfucker=StringRegExp($extpath, "(?i)7z")
if $checkfucker=0 Then
exit
Else
preinstall()
Endif
Endfunc

Func onlinechecker()
$checkfucker=StringRegExp($extpath, "(?i)7z")
if $checkfucker=0 Then
MsgBox(48, "KEITH Error", "Unrecognised extension format. aborting.")
Else
onlineinstaller()
Endif
Endfunc

Func preinstall()
$shitter = GUICreate("K-Meleon Extension Installer Helper", 368, 158, -1, -1, BitOR($WS_SYSMENU, $WS_EX_TOPMOST))
$Label1 = GUICtrlCreateLabel("K-Meleon Install folder:", 10, 5, 182, 20)
$Label2 = GUICtrlCreateLabel("KEIH will install this extension:", 10, 50, 182, 20)
$Label3 = GUICtrlCreateLabel($extpath, 10, 65, 360, 20)
$Label4= GUICtrlCreateLabel("( please note, K-Meleon will be restarted. )", 10, 80, 300, 20)
$Button_a= GUICtrlCreateButton("Install", 182, 100, 80, 20, BitOR($BS_FLAT, $WS_BORDER, $WS_EX_STATICEDGE))
$Button_b = GUICtrlCreateButton("Browse", 268, 20, 80, 20, BitOR($BS_FLAT, $WS_BORDER, $WS_EX_STATICEDGE))
$Button_x= GUICtrlCreateButton("Cancel", 268, 100,80, 20, BitOR($BS_FLAT, $WS_BORDER, $WS_EX_STATICEDGE))
$kmeleonpath = GUICtrlCreateInput("", 10, 20, 255, 20)
$kmpath = IniRead(@ScriptDir & "\exthelper.ini", "kmeleon", "1", "default")
GUICtrlSetData($kmeleonpath, $kmpath)
GUISetState()
    While 1
    $msg = GUIGetMsg()
    Select
            Case $msg = $Button_a
            sleep(44)
            GUIDelete($shitter)
            installshit()
                 Case $msg = $Button_b
                $kmpath = FileSelectFolder("Select K-Meleon's Folder: (the path where K-Meleon is installed)", "")
                $kmbinary2=($kmpath & "\k-meleon.exe")
                If FileExists($kmbinary2) Then
                IniWrite(@ScriptDir & "\exthelper.ini", "kmeleon", 1, $kmpath)
                $kmeleonpath = GUICtrlCreateInput("", 10, 20, 255, 20)
                GUICtrlSetData($kmeleonpath, $kmpath)
                Else
                MsgBox(48, "Error", "Invalid directory. Make sure to select K-Meleon's Install folder ")
Endif
         Case $msg = $Button_x
                GUIDelete($shitter)
                Return
                exit
         Case $msg = $GUI_EVENT_CLOSE
                GUIDelete($shitter)
                Return
                exit
      Endselect
    WEnd
EndFunc

func installshit()
$kmpath = IniRead(@ScriptDir & "\exthelper.ini", "kmeleon", "1", "default")
$kmbinary=($kmpath & "\k-meleon.exe")
If FileExists($kmbinary) Then
ProgressOn("KEIH: installing extension, please wait..", "initalising..", "0 percent", -1, -1, 16)
$kmbinary=($kmpath & "\k-meleon.exe")
ProgressSet(5, "6 percent", "extracting files")
$7zpath =(@ScriptDir & "\7z\7z.exe")
$pend = FileGetShortName($kmpath)
ProgressSet(15, "15 percent", "extracting..")
$pendparm1 = _StringInsert($pend, "-o", 0)
$pendparm2 = ($pendparm1 & " -y")
$pendparm3 = _StringInsert($pendparm2, " ", 0)
$pendparm7z=("""" & $extpath & """")
$extparm = ("x " & $pendparm7z)
ProgressSet(25, "25 percent", "extraction completed")
$overparm = ($extparm & $pendparm3)
$finalparam =($7zpath & " " & $overparm)
;shellexecute($7zpath, $overparm)
run($finalparam, "", @SW_HIDE)
ProgressSet(65, "65 percent", "extraction completed")
;MsgBox(4096, "Test", $finalparam)
ProgressSet(85, "85 percent", "registering components")
setkm()
ProgressSet(94, "94 percent", "finalising..")
checkloader()
ProgressOff()
Winwaitactive("[CLASS:KMeleon Browser Window]", "", 5)
sleep(888)
MsgBox(64, "K-Meleon Extension Installer Helper", "Extension was installed successfully.  ")
exit
Else
MsgBox(48, "Error", "Invalid directory. Make sure to select K-Meleon's Install folder ")
Endif
endfunc

Func setkm()
FileDelete($deletable1)
sleep(40)
FileDelete($deletable2)
endFunc

Func checkloader()
if processexists("loader.exe") Then
fireloader()
else
firekm()
endIf
EndFunc

func fireloader()
$kmLoader=($kmpath & "\loader.exe")
ProcessClose("loader.exe")
sleep(20)
ProcessClose("k-meleon.exe")
sleep(88)
Run($kmbinary)
sleep(4888)
Run($kmLoader)
EndFunc

Func firekm()
While ProcessExists("k-meleon.exe")
       WinClose("[CLASS:KMeleon Browser Window]", "");
       sleep(400);
       If WinActive("K-Meleon") Then
       Send("{Enter}")
       EndIf
Wend
sleep(1400)
Run($kmbinary)
endFunc

Func onlineinstaller()
$penddownload=(@tempdir & "\kmextpend.7z")
$extdown = GUICreate("Ext download", 220, 32, -1, -1, BitOR($WS_DLGFRAME, $WS_POPUP, $WS_EX_TOPMOST))
$Label1 = GUICtrlCreateLabel("downloading extension. please wait...", 8, 8, 200, 15)
GUISetState(@SW_SHOW)
WinSetOnTop("Ext download", "", 1)
InetGet($CmdLine[1], $penddownload, 1, 0)
GUIdelete($extdown)
sleep(800)
$kmpath = IniRead(@ScriptDir & "\exthelper.ini", "kmeleon", "1", "default")
$kmbinary=($kmpath & "\k-meleon.exe")
If FileExists($kmbinary) Then
ProgressOn("KEIH: installing extension, please wait..", "initalising..", "0 percent", -1, -1, 16)
$kmbinary=($kmpath & "\k-meleon.exe")
ProgressSet(5, "6 percent", "extracting files")
$7zpath =(@ScriptDir & "\7z\7z.exe")
$pend = FileGetShortName($kmpath)
ProgressSet(15, "15 percent", "extracting..")
$pendparm1 = _StringInsert($pend, "-o", 0)
$pendparm2 = ($pendparm1 & " -y")
$pendparm3 = _StringInsert($pendparm2, " ", 0)
$pendparm7z=("""" & $penddownload & """")
$extparm = ("x " & $pendparm7z)
ProgressSet(25, "25 percent", "extraction..")
$overparm = ($extparm & $pendparm3)
$finalparam =($7zpath & " " & $overparm)
;shellexecute($7zpath, $overparm)
run($finalparam, "", @SW_HIDE)
ProgressSet(65, "65 percent", "extraction completed")
;MsgBox(4096, "Test", $finalparam)
ProgressSet(85, "85 percent", "registering components")
setkm()
ProgressSet(94, "94 percent", "finalising..")
checkloader()
ProgressOff()
Winwaitactive("[CLASS:KMeleon Browser Window]", "", 5)
sleep(888)
MsgBox(64, "K-Meleon Extension Installer Helper", "Extension was installed successfully.  ")
exit
Else
MsgBox(48, "KEITH Error", "Invalid directory. Make sure to select K-Meleon's Install folder ")
Endif
EndFunc